input:not([type=checkbox]):not([type=radio]),
textarea,
select {
    -webkit-appearance: none;
    -moz-appearance: none;
    appearance: none;
}

input, textarea {
    outline: none;
    &:focus:required:invalid { border-color: red }
    &:required:valid { border-color: green }
}

:active, :hover, :focus {
    outline: 0 !important;
    outline-offset: 0 !important;
}

option::selection {background: #ccc;}
option::-moz-selection {background: #ccc;}
option::-webkit-selection {background: #ccc; color:#fff;}

input[type="number"]::-webkit-outer-spin-button,
input[type="number"]::-webkit-inner-spin-button {
    display: none;
}


.field {
    width: 100%;
    display: block;
    font-weight: 400;
    position: relative;
    background: transparent;
    $input-selector: "input[type=text], input[type=email], input[type=password], input[type=number], textarea";

    #{$input-selector} {
        margin: 0;
        width: 100%;
        height: rem(48);
        border: none;
        outline: none;
        color: var(--black);
        box-shadow: none;
        font-weight: 400;
        font-size: rem(17);
        line-height: rem(24);
        padding: rem(11) rem(48) rem(11) 0;
        background: transparent;
        display: inline-block;
        vertical-align: middle;
        border-bottom: rem(1) solid #9BA0AB;
        @include placeholder(#9BA0AB);

        &::-ms-clear {
            display: none;
            width: 0;
            height: 0;
        }

        &:focus,
        &:active {
            outline: none;
            @include placeholder(transparent);
        }

        &.error {
            border-color: red !important;
        }
    }

    textarea {
        height: auto;
        resize: none;
    }

    &__icon {
        fill: #5b3d38;
        font-size: 0;
        line-height: 0;
        top: calc(50% - 0.75rem);
        left: rem(16);
        height: rem(24);
        position: absolute;
        display: inline-block;
    }

    &__clear {
        top: 0;
        right: 0;
        z-index: 10;
        border: none;
        outline: none;
        font-size: 0;
        line-height: 0;
        width: rem(48);
        height: rem(48);
        fill: #9BA0AB;
        cursor: pointer;
        position: absolute;
        background: transparent;
        display: flex;
        align-items: center;
        justify-content: center;
        opacity: 0;
        visibility: hidden;
        transition: var(--transition-time);

        i {
            flex-shrink: 0;
            height: rem(18);
            display: inline-block;
        }
    }

    &--icon {

        #{$input-selector} {
            padding-left: rem(48);
        }
    }

    &--black {

        #{$input-selector} {
            border-bottom-color: var(--black);
            @include placeholder(var(--black));

            &:focus,
            &:active {
                @include placeholder(transparent);
            }
        }
    }

    &--filled {

        .field {

            &__clear {
                opacity: 1;
                visibility: visible;
                transition: var(--transition-time);
            }
        }
    }
}
